#version 330

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec3 texCoord;

layout(std140) uniform Matrices
{
  mat4 mMat;
  mat4 vMat;
  mat4 pMat;
};

out vsData
{
  vec3 fragPos;
  vec3 normal;
}
vs;

void main()
{

  // Output position of the vertex, in clip space : MVP * position
  // gl_Position = pMat * vMat * mMat * vec4(position,1);
  mat4 mvMat = vMat * mMat;
  gl_Position = mvMat * vec4(position, 1);
  // gl_Position = vec4(position,1.0);

  vs.fragPos = vec3(mvMat * vec4(position, 1));
  vs.normal = normalize(mat3(transpose(inverse(mvMat))) * normal);
  // vs.normal = normalize(mat3(mvMat) * normal);

  // mat3 nMat = mat3(transpose(inverse(vMat * mMat)));
  // vsNormal = normalize(vec3(pMat*vec4(nMat * normal,0)));

  // FragPos = vec3(Model * vec4(vertexPosition_modelspace,1));

  // Normal = normalize(NormalMatrix * vertexNormal);

  // Normal = normalize(mat3(transpose(inverse(Model))) * vertexNormal);
}
